/****************************************************************************
 *
 *  *********************************************************************
 *  *   Copyright (C) 2002-2005 KONICA MINOLTA MEDICAL&GAPHIC, INC.     *
 *  *   All rights reserved.                                            *
 *  *********************************************************************
 *
 *Υƥ̾Ρ
 *  DRYPRO MODEL 771 PEBǥХɥ饤
 *
 *Υ⥸塼̾Ρ
 *  PrnDev.h
 *
 *Υȡ
 *  ǥХɥ饤ФΥإåե
 *
 ****************************************************************************/

#ifndef _PRNDEV_H_
#define _PRNDEV_H_

#ifdef  __cplusplus
extern "C" {
#endif

#define  PRN_DRIVER_DIR   "/dev/PrnDev"
#define  PRN_DRIVER_NAME  "PrnDev"

/*MAJORֹ70ϡSCSIѤƤ롣250ѹ롣*/
/*#define  PRN_MAJOR        70*/
#define  PRN_MAJOR        250

/*ܡǧVendorDeviceID*/
#define  PRN_VENDOR_ID 0x1054  /*ΩID*/

/* Y.Kimura ǥХIDѲ뤿ᣲΥǥХIDб */
#define  PRN_DEVICE_ID_350C 0x350C    /*SH7751ID*/
#define  PRN_DEVICE_ID_350E 0x350E    /*SH7751ID*/
/*#define  PRN_DEVICE_ID 0x3505*/  /*SH7751ID*/

/* ǧ*/
#define  PRN_IRQ_MAGIC 0x35050


/***** IOȥ륳 *************************************************/
#define  IOC_GET_LOAD_STAT  0x5A01  /*ɥ饤еưΥơ*/
#define  IOC_CLOSE          0x5A02  /*  */
#define  IOC_MEM_READ       0x5A03  /*  */
#define  IOC_MEM_WRITE      0x5A04  /*  */
#define  IOC_DMA_WRITE      0x5A05  /*  */
#define  IOC_DMA_READ       0x5A06  /*  */
#define  IOC_GET_INTER      0x5A07  /*  */
#define  IOC_CP_USR_KERNEL  0x5A08  /*  */
#define  IOC_CP_KERNEL_USR  0x5A09  /*  */
#define  IOC_CONFIG_WRITE   0x5A0A  /*  */
#define  IOC_REG_READ       0x5A0B  /*  */
#define  IOC_REG_WRITE      0x5A0C  /*  */
#define  IOC_GET_SYS_ERR    0x5A0D  /*  */
#define  IOC_RES_READ       0x5A0E  /*  */
#define  IOC_CMD_WRITE      0x5A0F  /*  */
#define  IOC_PCILAR1_SET    0x5A10  /*  */
#define  IOC_GET_VERSION    0x5A11  /*  */
#define  IOC_MEM_READ_CS1   0x5A12  /*  */
#define  IOC_MEM_WRITE_CS1  0x5A13  /*  */

/***** IOȥǤLib-DriverּϤѥ᡼ *********************/
typedef struct _IOC_GET_LOAD
{
    unsigned long  phyAddr;  /*ʪɥ쥹*/
    unsigned long  phySize;  /*ʪ*/
    unsigned long  busAddr;
    short          loadSts;  /*ưΥ顼*/
    short          result;   /*IOC*/
}IOC_GET_LOAD_PARA;

typedef struct _IOC_CLOSE
{
    short          result;   /*ơ*/
    short          reserve1; /*ͽʥ饤ȹ礻*/
}IOC_CLOSE_PARA;

typedef struct _IOC_RES_READ_PARA
{
    unsigned long  offset;
    unsigned long  size;
    unsigned long  *dataPtr;
    short          result;
    short          reserve1;
}IOC_RES_READ_PARA;

typedef struct _IOC_CMD_WRITE
{
    unsigned long  offset;
    unsigned long  size;
    unsigned long  *dataPtr;
    short          result;
    short          reserve1;
}IOC_CMD_WRITE_PARA;

typedef struct _IOC_MEM_READ_PARA
{
    unsigned long  offset;
    unsigned long  size;
    unsigned long  *dataPtr;
    short          result;
    short          reserve1;
}IOC_MEM_READ_PARA;

typedef struct _IOC_MEM_WRITE
{
    unsigned long  offset;
    unsigned long  size;
    unsigned long  *dataPtr;
    short          result;
    short          reserve1;
}IOC_MEM_WRITE_PARA;

typedef struct _IOC_CONFIG_WRITE
{
    unsigned long  offset;
    unsigned long  size;
    unsigned char  *dataPtr;
    short          result;
    short          reserve1;
}IOC_CONFIG_WRITE_PARA;

typedef struct _IOC_CP_USR_KERNEL
{
    unsigned long  phyAddr;
    unsigned long  size;
    short          result;
    short          reserve1;
}IOC_CP_USR_KERNEL_PARA;

typedef struct _IOC_CP_KERNEL_USR
{
    unsigned long  phyAddr;
    unsigned long  size;
    short          result;
    short          reserve1;
}IOC_CP_KERNEL_USR_PARA;

typedef struct _IOC_GET_INTER
{
    long  interruptId;
    short          result;
    short          reserve1;
}IOC_GET_INTER_PARA;

typedef struct _IOC_DMA_WRITE
{
    unsigned long  size;
    unsigned long  addr;
    short          result;
    short          dmaLast;
}IOC_DMA_WRITE_PARA;

typedef struct _IOC_DMA_READ
{
    unsigned long  size;
    unsigned long  addr;
    short          result;
    short          dmaLast;
}IOC_DMA_READ_PARA;

typedef struct _IOC_REG_READ
{
    unsigned long  offset;
    unsigned long  size;
    unsigned long  rdData;
    short          result;
    short          reserve1;
}IOC_REG_READ_PARA;

typedef struct _IOC_REG_WRITE
{
    unsigned long  offset;
    unsigned long  size;
    unsigned long  wtData;
    short          result;
    short          reserve1;
}IOC_REG_WRITE_PARA;

typedef struct _IOC_GET_SYS_ERR
{
    short          sysErr;   /*ƥ२顼*/
    short          result;   /*IOC*/
}IOC_GET_SYS_ERR_PARA;

typedef struct _IOC_PCILAR1_SET
{
    unsigned long  offset;   /*PCILAR1ꥢɥ쥹*/
    short          result;   /*IOC*/
    short          reserve1;
}IOC_PCILAR1_SET_PARA;

typedef struct _IOC_GET_VERSION
{
    short          drvMajor; /*ɥ饤Х᥸㡼С*/
    short          drvMinor; /*ɥ饤ХޥʡС*/
    short          result;   /*IOC*/
    short          reserve1;
}IOC_GET_VERSION_PARA;

/*** ǡ꡼ɥ饤ȷϤIOȥ̿¸Хåե ************/
/*   ΥХåեϡХȤĶǡ꡼ɤȤ˻Ѥ */
typedef struct _IOC_MEM_ACC_CMD
{
    unsigned long  iocId;
    unsigned long  addr;
    unsigned long  size;
}IOC_MEM_ACC_CMD;


/***** ɥ쥹Ϣ **************************************************/
#define PRN_RESP_MEM_SIZE      (unsigned long)0x00040000  //256KХ
#define PRN_ADDR_CS2_IMG_SIZE  (unsigned long)0x03800000  //56MХ
#define PRN_RESP_MEM_ADDR_TOP  (unsigned long)0x08780000
#define PRN_CMD_MEM_SIZE       (unsigned long)0x00080000  //512KХ
#define PRN_CS2_ADDR_TOP       (unsigned long)0x08700000
#define PRN_CMD_MEM_ADDR_TOP   (unsigned long)0x08700020
#define PRN_CS2_IMG_ADDR_TOP   (unsigned long)0x08800000
#define PRN_CS3_IMG_ADDR_TOP   (unsigned long)0x0C000000

#define PRN_ADDR_CS0_TOP       (unsigned long)0x00000000
#define PRN_ADDR_CS0_TAIL      (unsigned long)0x03FFFFFF
#define PRN_ADDR_CS1_TOP       (unsigned long)0x04000000
#define PRN_ADDR_CS1_TAIL      (unsigned long)0x07FFFFFF
#define PRN_ADDR_CS2_TOP       (unsigned long)0x08000000
#define PRN_ADDR_CS2_TAIL      (unsigned long)0x0BFFFFFF
#define PRN_ADDR_CS3_TOP       (unsigned long)0x0C000000
#define PRN_ADDR_CS3_TAIL      (unsigned long)0x0FFFFFFF
#define PRN_ADDR_CS4_TOP       (unsigned long)0x10000000
#define PRN_ADDR_CS4_TAIL      (unsigned long)0x13FFFFFF
#define PRN_ADDR_CS5_TOP       (unsigned long)0x14000000
#define PRN_ADDR_CS5_TAIL      (unsigned long)0x17FFFFFF
#define PRN_ADDR_CS6_TOP       (unsigned long)0x1C000000
#define PRN_ADDR_CS6_TAIL      (unsigned long)0x1FFFFFFF
#define PRN_ADDR_CS2_IMG_TOP   (unsigned long)0x08600000
#define PRN_ADDR_CS2_IMG_TAIL  (unsigned long)0x0BFFFFFF


/***** 쥸եåȥɥ쥹 **************************************/
#define PRN_PCIINT_OFST        (unsigned long)0x00000030
#define PRN_PCIDPA0_OFST       (unsigned long)0x00000080  /*CH-0 PCIɥ쥹*/
#define PRN_PCIDLA0_OFST       (unsigned long)0x00000084  /*CH-0 륢ɥ쥹*/
#define PRN_PCIDTC0_OFST       (unsigned long)0x00000088  /*CH-0 žХ*/
#define PRN_PCIDCR0_OFST       (unsigned long)0x0000008C  /*CH-0 ȥ*/
#define PRN_PCIDPA1_OFST       (unsigned long)0x00000090  /*CH-1 PCIɥ쥹*/
#define PRN_PCIDLA1_OFST       (unsigned long)0x00000094  /*CH-1 륢ɥ쥹*/
#define PRN_PCIDTC1_OFST       (unsigned long)0x00000098  /*CH-1 žХ*/
#define PRN_PCIDCR1_OFST       (unsigned long)0x0000009C  /*CH-1 ȥ*/


/***** 쥸ǡ *************************************************/
#define PRN_DMA_COMPLETE       (unsigned long)0x00000040
#define PRN_DMA_START          (unsigned long)0x00000001
#define PRN_DMA_PCI2LOCAL      (unsigned long)0x00000000
#define PRN_DMA_LOCAL2PCI      (unsigned long)0x00000004
#define PRN_DMA_INTR_ENABLE    (unsigned long)0x00000080

/***** FPGA Config饤ӥå ******************************************/
#define PRN_CNF_DIN            (unsigned long)0x00010000
#define PRN_CNF_CCLK           (unsigned long)0x00020000
#define PRN_CNF_XPROGRAM       (unsigned long)0x00040000
#define PRN_CNF_XINIT          (unsigned long)0x01000000
#define PRN_CNF_DONE           (unsigned long)0x02000000

/***** ॢȻ *****************************************************/
#define PRN_CNF_INIT_TIMEOUT   (unsigned long)100  //100*100usec=10msec
#define PRN_CNF_DONE_TIMEOUT   (unsigned long)100  //100*100usec=10msec

/***** ͥǤΥ顼 ***************************************************/
#define PRN_KER_VERIFY_ERR  (unsigned short)-301

#ifdef	__cplusplus
}
#endif

#endif

