/****************************************************************************
 *
 *  *********************************************************************
 *  *   Copyright (C) 2002-2005 KONICA MINOLTA MEDICAL&GAPHIC, INC.     *
 *  *   All rights reserved.                                            *
 *  *********************************************************************
 *
 *Υƥ̾Ρ
 *  DRYPRO MODEL 771 PEBǥХɥ饤
 *
 *Υ⥸塼̾Ρ
 *  PrnIf.h
 *
 *Υȡ
 *  ǥХɥ饤ФΥ󥿡ե
 *
 ****************************************************************************/

#ifndef _PRNIF_H_
#define _PRNIF_H_

#ifdef  __cplusplus
extern "C" {
#endif

/***** DLLؿ ******************************************************/
#define  PRN_SUCCESS                   (short)0
#define  PRN_DUPLICATE_OPEN            (short)-200
#define  PRN_FAILED                    (short)-201
#define  PRN_DEV_NOT_OPEN              (short)-202
#define  PRN_REG_ACC_FAILED            (short)-203
#define  PRN_SIZE_ILLEGAL              (short)-204
#define  PRN_OFFSET_ILLEGAL            (short)-205
#define  PRN_CMD_WRITE_TIMEOUT         (short)-206
#define  PRN_DUPLICATE_DMA             (short)-207
#define  PRN_DRIVER_NOT_FOUND          (short)-208
#define  PRN_DEVICE_UNRECOGNIZE        (short)-209
#define  PRN_DRIVER_MINOR_UNMATCH      (short)-210
#define  PRN_PHY_MEM_GET_FAILED        (short)-211
#define  PRN_BORAD_MEM_FAILED          (short)-212
#define  PRN_FILE_SIZE_ILLEGAL         (short)-213
#define  PRN_FILE_OPEN_FAILED          (short)-214
#define  PRN_CONF_INIT_NOT_HIGH        (short)-215
#define  PRN_CONF_INIT_ILLEGAL_0       (short)-216
#define  PRN_CONF_NOT_DONE             (short)-217
#define  PRN_ADDR_ILLEGAL              (short)-218
#define  PRN_MEM_READ_TIMEOUT          (short)-219
#define  PRN_MEM_WRITE_TIMEOUT         (short)-220
#define  PRN_USER_ADDR_ILLEGAL         (short)-221
#define  PRN_KERNEL_ADDR_ILLEGAL       (short)-222
#define  PRN_FILE_WRITE_FAILED         (short)-223
#define  PRN_DISK_FULL                 (short)-224
#define  PRN_FD_ILLEGAL                (short)-225
#define  PRN_CONF_INIT_NOT_LOW         (short)-226

/***** ƥ२顼顼 *******************************************/
#define  SYS_ERR_FIND_DEV_FAILED       (short)-301
#define  SYS_ERR_REG_DEV_FAILED        (short)-302
#define  SYS_ERR_REQ_IRQ_FAILED        (short)-303
#define  SYS_ERR_FASYNC_HELP_FAILED    (short)-304
#define  SYS_ERR_IOCTL_NO_EXIST        (short)-305
#define  SYS_ERR_IO_PARA_VERI_ERR      (short)-306
#define  SYS_ERR_PCILAR1_ERR           (short)-307
#define  SYS_ERR_RESP_READ_TIMEOUT     (short)-308
#define  SYS_ERR_DMA_TIMEOUT           (short)-309
#define  SYS_ERR_DUPLICATE_OPEN        (short)-310
#define  SYS_ERR_CONF_INIT_NOT_LOW     (short)-311
#define  SYS_ERR_CONF_INIT_NOT_HIGH    (short)-312
#define  SYS_ERR_CONF_INIT_ILLEGAL_0   (short)-313
#define  SYS_ERR_CONF_NOT_DONE         (short)-314



/***** Ƚѥ(ƥȥץǻ) *********************************/
#define  PRN_INTR_DMA_COMPLETE         (short)1
#define  PRN_INTR_RESPONSE             (short)2
#define  PRN_INTERUPT_NOT_HAPPENED     (short)0

/***** 饤֥ؿ ***************************************************/
/*** ǥץѴؿ ***/
/*-------2002.10.11) S.kaneko */
short    PrnDevOpen( int *prnFd, unsigned long *phySize, unsigned long *phyBuf, unsigned long *busAddr );
short    PrnDevClose( int prnFd );
short    PrnRespRead( unsigned long offset, unsigned long size, long *dataPtr );
short    PrnCmdWrite( unsigned long offset, unsigned long size, long *dataPtr );
short    FpgaConfWrite( char *fileName );
short    GetLastError(  char *errMessage );
/*** ͽѴؿ ***/
short    PrnMemRead( unsigned long  addr,  unsigned long  size,  long  *dataPtr );
short    PrnMemWrite( unsigned long  addr,  unsigned long  size, long  *dataPtr );
short    PrnImageDMAWrite( unsigned long offset, unsigned long size, unsigned long *dataPtr );
short    PrnImageDMARead( unsigned long offset, unsigned long size, unsigned long *dataPtr );
short    PrnCopyUserToKernel( unsigned long *usrBuf, unsigned long kerBuf, unsigned long size );
short    PrnCopyKernelToUser( unsigned long kerBuf, unsigned long *usrBuf, unsigned long size );
/*** ǥХåѴؿ  ***/
short    PrnGetInterruptId( long *InterruptId );
short    PrnDbgLogReq( char *logfile );
short    PrnDbgLogWrite( char *msg );
short    PrnDMAWrite( unsigned long addr,  unsigned long size,  unsigned long *dataPtr );
short    PrnDMARead( unsigned long addr,  unsigned long size,  unsigned long *dataPtr );
short    PrnLarSet( void );
short    PrnRegWrite( unsigned long offset, unsigned long wtData );
short    PrnRegRead( unsigned long offset, unsigned long *rdData );
short    PrnGetVersion( unsigned short *drvMajor, unsigned short *drvMinor, unsigned short *libMajor, unsigned short *libMinor );

/*extern*/
/*-------2002.10.11) S.kaneko */
extern short    PrnDevOpen( int *prnFd, unsigned long *phySize, unsigned long *phyBuf, unsigned long *busAddr );
extern short    PrnDevClose( int prnFd );
extern short    PrnRespRead( unsigned long offset, unsigned long size, long *dataPtr );
extern short    PrnCmdWrite( unsigned long offset, unsigned long size, long *dataPtr );
extern short    FpgaConfWrite( char *fileName );
extern short    GetLastError(  char *errMessage );
/*** ͽѴؿ ***/
extern short    PrnMemRead( unsigned long  addr,  unsigned long  size,  long  *dataPtr );
extern short    PrnMemWrite( unsigned long  addr,  unsigned long  size, long  *dataPtr );
extern short    PrnImageDMAWrite( unsigned long offset, unsigned long size, unsigned long *dataPtr );
extern short    PrnImageDMARead( unsigned long offset, unsigned long size, unsigned long *dataPtr );
extern short    PrnCopyUserToKernel( unsigned long *usrBuf, unsigned long kerBuf, unsigned long size );
extern short    PrnCopyKernelToUser( unsigned long kerBuf, unsigned long *usrBuf, unsigned long size );
/*** ǥХåѴؿ  ***/
extern short    PrnGetInterruptId( long *InterruptId );
extern short    PrnDbgLogReq( char *logfile );
extern short    PrnDbgLogWrite( char *msg );
extern short    PrnDMAWrite( unsigned long addr,  unsigned long size,  unsigned long *dataPtr );
extern short    PrnDMARead( unsigned long addr,  unsigned long size,  unsigned long *dataPtr );
extern short    PrnLarSet( void );
extern short    PrnRegWrite( unsigned long offset, unsigned long wtData );
extern short    PrnRegRead( unsigned long offset, unsigned long *rdData );
extern short    PrnGetVersion( unsigned short *drvMajor, unsigned short *drvMinor,  unsigned short *libMajor, unsigned short *libMinor );

#ifdef	__cplusplus
}
#endif

#endif

